/*----------------------------------------------------------
	DirectX9HvO~O
		DirectX GraphicsTv

	DXGSample06.cpp
		u{I3DvO~Ov

	(C) 2003 NARITA, Takuro
		E-Mail	narita@a1.mbn.or.jp
--------------------------------------------------------------*/

#define STRICT					// ^`FbNɍsȂ
//#define WIN32_LEAN_AND_MEAN	// wb_[炠܂gȂ֐Ȃ
#define WINVER	0x040A			// Windows 98 & Windows 2000ȍ~

#include <windows.h>
#include <tchar.h>
#include <d3dx9.h>
#include <dxerr9.h>

#include "SelectDevice.h"
#include "resource.h"

#define RELEASE(x)	if(x){x->Release();x=NULL;}

/*-------------------------------------------
	O[oϐ(AvP[V֘A)
--------------------------------------------*/
HINSTANCE	g_hInstance		= NULL;	// CX^XEnh
HWND		g_hWindow		= NULL;	// EChEEnh
HMENU		g_hMenu			= NULL;	// j[Enh

TCHAR		g_szAppTitle[]	= _T("DirectX 9.0 Graphics Sample06");
TCHAR		g_szWndClass[]	= _T("DX9GS06");

RECT		g_rectWindow;			// EChEE[hł̍Ō̈ʒu

// AvP[V̓tO
bool		g_bActive		= false;	// ANeBu

/*-------------------------------------------
	O[oϐ(foCX̐ݒ֘A)
--------------------------------------------*/
// N̉ʃ[h
bool		g_bWindow = true;

// ]ʃTCY(EChE)
SIZE		g_sizeWindowMode	= { 640, 480 };
// ]ʃTCY(tXN[)
SIZE		g_sizeFullMode	= { 1024, 768 };

// ]fBXvCEtH[}bg
D3DFORMAT	g_fmtDisplay[] =	{	D3DFMT_X8R8G8B8, D3DFMT_X1R5G5B5, D3DFMT_R5G6B5 };
int			g_fmtDisplayNum = sizeof(g_fmtDisplay) / sizeof(g_fmtDisplay[0]);
// ]郌_OEeNX`̃tH[}bg
D3DFORMAT	g_fmtRendTexter[] =	{	D3DFMT_X8R8G8B8, D3DFMT_X1R5G5B5, D3DFMT_R5G6B5 };
int			g_fmtRendTexterNum = sizeof(g_fmtRendTexter) / sizeof(g_fmtRendTexter[0]);
// ][x/XeVobt@̃tH[}bg(D3DFMT_UNKNOWNŖgp)
D3DFORMAT	g_fmtDepthStencil = D3DFMT_D24S8;
// ]}`ETvÕ^Cv
//D3DMULTISAMPLE_TYPE g_MultiSampleType[] =	{ D3DMULTISAMPLE_4_SAMPLES, D3DMULTISAMPLE_NONMASKABLE, D3DMULTISAMPLE_NONE	};
D3DMULTISAMPLE_TYPE g_MultiSampleType[] =	{ D3DMULTISAMPLE_NONE };
int					g_MultiSampleTypeNum = sizeof(g_MultiSampleType) / sizeof(g_MultiSampleType[0]);
// ]Present̎s[g
UINT		g_Interval = D3DPRESENT_INTERVAL_IMMEDIATE;

/*-------------------------------------------
	O[oϐ(DirectX֘A)
--------------------------------------------*/
bool g_bD3DEmpty = true;						// tO

// C^[tFCX
LPDIRECT3D9				g_pD3D			= NULL; // Direct3DC^[tFCX
LPDIRECT3DDEVICE9		g_pD3DDevice	= NULL; // Direct3DDeviceC^[tFCX
D3DPRESENT_PARAMETERS	g_D3DPP;				// D3DDevice̐ݒ()

D3DPRESENT_PARAMETERS	g_D3DPPWindow;			// D3DDevice̐ݒ(EChEE[hp)
D3DPRESENT_PARAMETERS	g_D3DPPFull;			// D3DDevice̐ݒ(tXN[E[hp)

D3DFORMAT				g_fmtRendTexterWindow;	// _OEeNX`̃tH[}bg(EChEp)
D3DFORMAT				g_fmtRendTexterFull;	// _OEeNX`̃tH[}bg(tXN[p)

// _f[^̌`
struct XYZBuffer   // _obt@1Ɏ߂f[^
{
	FLOAT x, y, z;
};

struct ColBuffer   // _obt@2ɔ[߂f[^
{
	D3DCOLOR color;
};

// _vf
D3DVERTEXELEMENT9 g_decl[] = 
{
	{ 0, 0, D3DDECLTYPE_FLOAT3,   D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
	{ 1, 0, D3DDECLTYPE_D3DCOLOR, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR,    0 },
	D3DDECL_END()   // z̏I
};

LPDIRECT3DVERTEXDECLARATION9 g_pVertexDeclaration = NULL;	// _錾IuWFNg

// _obt@ƃCfbNXEobt@
LPDIRECT3DVERTEXBUFFER9 g_pD3DVBXYZBuffer = NULL;	// XYZBuffer̒_obt@
LPDIRECT3DVERTEXBUFFER9 g_pD3DVBColBuffer = NULL;	// ColBuffer̒_obt@

LPDIRECT3DINDEXBUFFER9 g_pD3DIBuffer = NULL;		// CfbNXEobt@

// VF[_
LPDIRECT3DVERTEXSHADER9	g_pVertexShader = NULL;		// _VF[_󂯎ϐ
LPDIRECT3DPIXELSHADER9	g_pPixelShader = NULL;		// sNZEVF[_

bool g_bDeviceLost = false;							// foCX̏tO

/*-------------------------------------------
	֐`
--------------------------------------------*/

LRESULT CALLBACK MainWndProc(HWND hWnd,UINT msg,UINT wParam,LONG lParam);

/*-------------------------------------------
	AvP[ViŏɈxĂ΂j
--------------------------------------------*/
HRESULT InitApp(HINSTANCE hInst)
{
	// AvP[ṼCX^XEnhۑ
	g_hInstance = hInst;

	// IME֎~
	ImmDisableIME(-1);

	// EChEENX̓o^
	WNDCLASSEX wcex;
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)MainWndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInst;
	wcex.hIcon			= LoadIcon(hInst, (LPCTSTR)IDI_ICON1);
	wcex.hIconSm		= (HICON)LoadImage(hInst, (LPCTSTR)IDI_ICON1, IMAGE_ICON,
									16, 16, LR_DEFAULTCOLOR);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= g_bWindow ? MAKEINTRESOURCE(IDR_MENU1) : NULL;
	wcex.lpszClassName	= g_szWndClass;

	if (!RegisterClassEx(&wcex))
		return DXTRACE_ERR("InitApp", GetLastError());

	// CEEChE쐬
	g_rectWindow.top	= 0;
	g_rectWindow.left	= 0;
	g_rectWindow.right	= g_sizeWindowMode.cx;
	g_rectWindow.bottom	= g_sizeWindowMode.cy;
	AdjustWindowRect(&g_rectWindow, WS_OVERLAPPEDWINDOW, TRUE);
	g_rectWindow.right	= g_rectWindow.right - g_rectWindow.left;
	g_rectWindow.bottom	= g_rectWindow.bottom - g_rectWindow.top;
	g_rectWindow.top	= 0;
	g_rectWindow.left	= 0;

	RECT rect;
	if (g_bWindow)
	{
		// (EChEE[hp)
		rect.top	= CW_USEDEFAULT;
		rect.left	= CW_USEDEFAULT;
		rect.right	= g_rectWindow.right;
		rect.bottom	= g_rectWindow.bottom;
	}
	else
	{
		// (tXN[E[hp)
		rect.top	= 0;
		rect.left	= 0;
		rect.right	= g_sizeFullMode.cx;
		rect.bottom	= g_sizeFullMode.cy;

		g_hMenu = LoadMenu(g_hInstance, MAKEINTRESOURCE(IDR_MENU1));
	}

	g_hWindow = CreateWindow(g_szWndClass, g_szAppTitle,
		g_bWindow ? WS_OVERLAPPEDWINDOW : WS_POPUP,
			rect.left, rect.top, rect.right, rect.bottom,
			NULL, NULL, hInst, NULL);
	if (g_hWindow == NULL)
		return DXTRACE_ERR("InitApp", GetLastError());

	// EChE\
	ShowWindow(g_hWindow, SW_SHOWNORMAL);
	UpdateWindow(g_hWindow);

	return S_OK;
}

/*-------------------------------------------
	DirectX Graphics
--------------------------------------------*/
HRESULT InitDXGraphics(void)
{
	// Direct3DIuWFNg̍쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (g_pD3D == NULL)
		return DXTRACE_ERR("InitDXGraphics Direct3DCreate9", E_FAIL);

	// foCXݒ̑I
	UINT Adapter;
	D3DDEVTYPE Device;
	HRESULT hr = SelectD3DDevice(Adapter, Device);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics SelectD3DDevice", hr);

	// D3DDeviceIuWFNg̍쐬
	if (g_bWindow)
		g_D3DPP = g_D3DPPWindow;
	else
		g_D3DPP = g_D3DPPFull;

	hr = g_pD3D->CreateDevice(Adapter, Device, g_hWindow,
						D3DCREATE_HARDWARE_VERTEXPROCESSING, &g_D3DPP, &g_pD3DDevice);
	if (FAILED(hr))
	{
		hr = g_pD3D->CreateDevice(Adapter, Device, g_hWindow,
						D3DCREATE_SOFTWARE_VERTEXPROCESSING, &g_D3DPP, &g_pD3DDevice);
		if (FAILED(hr))
			return DXTRACE_ERR("InitDXGraphics CreateDevice", hr);
	}

	// r[|[g̐ݒ
	D3DVIEWPORT9 vp;
	vp.X		= 0;
	vp.Y		= 0;
	vp.Width	= g_D3DPP.BackBufferWidth;
	vp.Height	= g_D3DPP.BackBufferHeight;
	vp.MinZ		= 0.0f;
	vp.MaxZ		= 1.0f;
	hr = g_pD3DDevice->SetViewport(&vp);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics SetViewport", hr);

	// _錾IuWFNg̍쐬
	hr = g_pD3DDevice->CreateVertexDeclaration(g_decl, &g_pVertexDeclaration);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreateVertexDeclaration", hr); // G[

	// _obt@̍쐬
	// uXYZBufferv߂钸_obt@1
	hr = g_pD3DDevice->CreateVertexBuffer(
			sizeof(XYZBuffer)*8,		// obt@ETCY(̂̒_)
			0,							// gp@
			0,							// FVF_obt@
			D3DPOOL_MANAGED,			// Direct3DŃǗ
			&g_pD3DVBXYZBuffer,			// _obt@󂯎ϐ
			NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreateVertexBuffer", hr); // G[
	// uColBufferv߂钸_obt@2
	hr = g_pD3DDevice->CreateVertexBuffer(
			sizeof(ColBuffer)*8,		// obt@ETCY
			0,							// gp@
			0,							// FVF_obt@
			D3DPOOL_MANAGED,			// Direct3DŃǗ
			&g_pD3DVBColBuffer,			// _obt@󂯎ϐ
			NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreateVertexBuffer", hr); // G[

	// _obt@ւ̏
	// XYZBuffer߂钸_obt@1ɏ
	XYZBuffer *pXYZBuffer;
	hr = g_pD3DVBXYZBuffer->Lock(
			0, 0,             // ŜbN
			(LPVOID*)&pXYZBuffer, 0);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics Lock", hr); // G[
	// ̂̒_f[^
	pXYZBuffer[0].x =  1.0f; pXYZBuffer[0].y =  1.0f; pXYZBuffer[0].z =  1.0f;
	pXYZBuffer[1].x =  1.0f; pXYZBuffer[1].y =  1.0f; pXYZBuffer[1].z = -1.0f;
	pXYZBuffer[2].x =  1.0f; pXYZBuffer[2].y = -1.0f; pXYZBuffer[2].z =  1.0f;
	pXYZBuffer[3].x =  1.0f; pXYZBuffer[3].y = -1.0f; pXYZBuffer[3].z = -1.0f;
	pXYZBuffer[4].x = -1.0f; pXYZBuffer[4].y =  1.0f; pXYZBuffer[4].z =  1.0f;
	pXYZBuffer[5].x = -1.0f; pXYZBuffer[5].y =  1.0f; pXYZBuffer[5].z = -1.0f;
	pXYZBuffer[6].x = -1.0f; pXYZBuffer[6].y = -1.0f; pXYZBuffer[6].z =  1.0f;
	pXYZBuffer[7].x = -1.0f; pXYZBuffer[7].y = -1.0f; pXYZBuffer[7].z = -1.0f;
	g_pD3DVBXYZBuffer->Unlock(); // AbN
	// ColBuffer߂钸_obt@2ɏ
	ColBuffer *pColBuffer;
	hr = g_pD3DVBColBuffer->Lock(0, 0, (LPVOID*)&pColBuffer, 0);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics Lock", hr);
	// _̐Ff[^
	pColBuffer[0].color = D3DCOLOR_XRGB(0xff, 0xff, 0xff);
	pColBuffer[1].color = D3DCOLOR_XRGB(0xff, 0xff, 0x00);
	pColBuffer[2].color = D3DCOLOR_XRGB(0xff, 0x00, 0xff);
	pColBuffer[3].color = D3DCOLOR_XRGB(0xff, 0x00, 0x00);
	pColBuffer[4].color = D3DCOLOR_XRGB(0x00, 0xff, 0xff);
	pColBuffer[5].color = D3DCOLOR_XRGB(0x00, 0xff, 0x00);
	pColBuffer[6].color = D3DCOLOR_XRGB(0x00, 0x00, 0xff);
	pColBuffer[7].color = D3DCOLOR_XRGB(0x00, 0x00, 0x00);
	g_pD3DVBColBuffer->Unlock();	// AbN

	// CfbNXEobt@̍쐬
	hr = g_pD3DDevice->CreateIndexBuffer(
			36 * 2,					// 36_16rbgECfbNXEobt@
			0,						// gp@
			D3DFMT_INDEX16,			// 16rbgECfbNXEobt@
			D3DPOOL_MANAGED,		// Direct3DŃǗ
			&g_pD3DIBuffer,			// CfbNXEobt@󂯎ϐ
			NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreateIndexBuffer", hr); // G[

	// CfbNXEobt@ւ̏
	WORD *pIndex;
	hr = g_pD3DIBuffer->Lock(0, 0, (LPVOID*)&pIndex, 0);  // bN
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics Lock", hr);
	// CfbNX̏
	pIndex[0] = 0; pIndex[1] = 3; pIndex[2] = 1;	pIndex[3] = 0; pIndex[4] = 2; pIndex[5] = 3;
	pIndex[6] = 0; pIndex[7] = 5; pIndex[8] = 4;	pIndex[9] = 0; pIndex[10] = 1; pIndex[11] = 5;
	pIndex[12] = 4; pIndex[13] = 2; pIndex[14] = 0;	pIndex[15] = 4; pIndex[16] = 6; pIndex[17] = 2;
	pIndex[18] = 5; pIndex[19] = 6; pIndex[20] = 4;	pIndex[21] = 5; pIndex[22] = 7; pIndex[23] = 6;
	pIndex[24] = 3; pIndex[25] = 6; pIndex[26] = 7;	pIndex[27] = 3; pIndex[28] = 2; pIndex[29] = 6;
	pIndex[30] = 1; pIndex[31] = 7; pIndex[32] = 5;	pIndex[33] = 1; pIndex[34] = 3; pIndex[35] = 7;
	g_pD3DIBuffer->Unlock();    // AbN

	// _VF[_EvÕAZu
	LPD3DXBUFFER pCode;
	hr = D3DXAssembleShaderFromFile(_T("DXGSample06.vs"), NULL, NULL, 0, &pCode, NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics D3DXAssembleShaderFromFile DXGSample06.vs", hr);   // G[
	// _VF[_
	hr = g_pD3DDevice->CreateVertexShader((DWORD*)pCode->GetBufferPointer(), &g_pVertexShader);
	RELEASE(pCode);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreateVertexShader", hr);  // G[

	// sNZEVF[_EvÕAZu
	hr = D3DXAssembleShaderFromFile(_T("DXGSample06.ps"), NULL, NULL, 0, &pCode, NULL);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics D3DXAssembleShaderFromFile DXGSample06.ps", hr);   // G[
	// sNZEVF[_
	hr =g_pD3DDevice->CreatePixelShader((DWORD*)pCode->GetBufferPointer(), &g_pPixelShader);
	RELEASE(pCode);
	if (FAILED(hr))
		return DXTRACE_ERR("InitDXGraphics CreatePixelShader", hr);  // G[

	return S_OK;
}

/*-------------------------------------------
	D3DɊǗȂIuWFNg̏Ȃ
--------------------------------------------*/
HRESULT InitD3DObject(void)
{
	// _OEXe[g̐ݒ
	// Zobt@̐ݒ
	g_pD3DDevice->SetRenderState(D3DRS_ZENABLE,
		g_D3DPP.EnableAutoDepthStencil ? D3DZB_TRUE : D3DZB_FALSE);

	// }`TvO̐ݒ
	g_pD3DDevice->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS,
		g_D3DPP.MultiSampleType != D3DMULTISAMPLE_NONE ? TRUE : FALSE);

	// O[[EVF[fBOɐݒ
	g_pD3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_GOURAUD);

	// JO
	g_pD3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);  // wʂJO

	return S_OK;
}

/*--------------------------------------------
	ʂ̕`揈
--------------------------------------------*/
HRESULT Render(void)
{
	// V[̃NA
	DWORD Flags = (g_D3DPP.EnableAutoDepthStencil == TRUE) ?
		D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER | D3DCLEAR_STENCIL : D3DCLEAR_TARGET;
	g_pD3DDevice->Clear(0, NULL, Flags, D3DCOLOR_XRGB(0, 0, 255), 1.0f, 0);

	// V[̕`Jn
	if (SUCCEEDED(g_pD3DDevice->BeginScene()))
	{
		// V[̕`
		D3DXMATRIX matWorld;								// [hϊs
		FLOAT ry = ((GetTickCount() % 2000) / 2000.0f) * 6.283f;	// ]px(2b1])
		D3DXMatrixRotationY(&matWorld, ry);					// Y𒆐Sɉ]

		D3DXMATRIX matView;									// r[ϊs
		D3DXVECTOR3 vEye(0.0f, 5.0f, -5.0f);				// J̍W
		D3DXVECTOR3 vAt(0.0f, 0.0f, 0.0f);					// _
		D3DXVECTOR3 vUp(0.0f, 1.0f, 0.0f);					// J̏xNg
		D3DXMatrixLookAtLH(&matView, &vEye, &vAt, &vUp);	// r[ϊs

		D3DXMATRIX matProj;									// ϊs
		D3DXMatrixPerspectiveFovLH(&matProj,
				3.1415f/3.0f,								// p60x
				(float)g_D3DPP.BackBufferWidth/(float)g_D3DPP.BackBufferHeight,	// AXyNg
				3.0f,		// Oeʂ܂ł̋
				15.0f);		// eʂ܂ł̋

		D3DXMATRIX mat;
		mat = matWorld * matView * matProj;					// Ŝ̕ϊs
		D3DXMatrixTranspose( &mat, &mat );

		g_pD3DDevice->SetVertexShaderConstantF(0, (float*)&mat, 4);  // c0`c3WX^ɐݒ

		// _錾̓o^
		HRESULT hr;
		hr = g_pD3DDevice->SetVertexDeclaration(g_pVertexDeclaration);

		// _Xg[̓o^
		hr = g_pD3DDevice->SetStreamSource(0, g_pD3DVBXYZBuffer, 0, sizeof(XYZBuffer));  // Xg[1̐ݒ
		hr = g_pD3DDevice->SetStreamSource(1, g_pD3DVBColBuffer, 0, sizeof(ColBuffer));  // Xg[2̐ݒ

		// CfbNXEobt@̓o^
		hr = g_pD3DDevice->SetIndices(g_pD3DIBuffer);

		// VF[_̓o^
		hr = g_pD3DDevice->SetVertexShader(g_pVertexShader);   // _VF[_̓o^
		hr = g_pD3DDevice->SetPixelShader(g_pPixelShader);     // sNZEVF[_̓o^

		// `
		hr = g_pD3DDevice->DrawIndexedPrimitive(
			D3DPT_TRIANGLELIST,		// v~eBu^ƂāAOp`Xgw
			0,						// ŏ̒_CfbNX܂ł̃ItZbg
			0,						// ŏ̒_CfbNX
			8,						// _̐
			0,						// CfbNXEobt@̒ŁA_̓ǂݎJnʒu
			12);					// `悷v~eBu̐

		// V[̕`I
		g_pD3DDevice->EndScene();
	}

	// V[̕\
	return g_pD3DDevice->Present(NULL, NULL, NULL, NULL);
}

/*-------------------------------------------
	D3DɊǗȂIuWFNg̏I
--------------------------------------------*/
HRESULT CleanupD3DObject(void)
{
	return S_OK;
}

/*-------------------------------------------
	EChEETCY̕ύX
--------------------------------------------*/
HRESULT ChangeWindowSize(void)
{
	// EChẼNCAg̈ɍ킹
	CleanupD3DObject();

	HRESULT hr = g_pD3DDevice->Reset(&g_D3DPP);
	if (FAILED(hr))
	{
		if (hr == D3DERR_DEVICELOST)
			g_bDeviceLost = true;
		else
			DestroyWindow(g_hWindow);
		return DXTRACE_ERR("ChangeWindowSize Reset", hr);
	}
	hr = InitD3DObject();
	if (FAILED(hr))
	{
		DestroyWindow(g_hWindow);
		return DXTRACE_ERR("ChangeWindowSize InitD3DObject", hr);
	}

	// r[|[g̐ݒ
	D3DVIEWPORT9 vp;
	vp.X		= 0;
	vp.Y		= 0;
	vp.Width	= g_D3DPP.BackBufferWidth;
	vp.Height	= g_D3DPP.BackBufferHeight;
	vp.MinZ		= 0.0f;
	vp.MaxZ		= 1.0f;
	hr = g_pD3DDevice->SetViewport(&vp);
	if (FAILED(hr))
	{
		DXTRACE_ERR("ChangeWindowSize SetViewport", hr);
		DestroyWindow(g_hWindow);
	}
	return hr;
}

/*-------------------------------------------
	ʃ[h̕ύX
--------------------------------------------*/
void ChangeDisplayMode(void)
{
	g_bWindow = !g_bWindow;

	CleanupD3DObject();

	if (g_bWindow)
	{
		g_D3DPP = g_D3DPPWindow;
	}
	else
	{
		g_D3DPP = g_D3DPPFull;
		GetWindowRect(g_hWindow, &g_rectWindow);
	}

	HRESULT hr = g_pD3DDevice->Reset(&g_D3DPP);
	if (FAILED(hr))
	{
		if (hr == D3DERR_DEVICELOST)
			g_bDeviceLost = true;
		else
			DestroyWindow(g_hWindow);
		DXTRACE_ERR("ChangeDisplayMode Reset", hr);
		return;
	}

	hr = InitD3DObject();
	if (FAILED(hr))
	{
		DXTRACE_ERR("ChangeDisplayMode InitD3DObject", hr);
		DestroyWindow(g_hWindow);
		return;
	}

	if (g_bWindow)
	{
		SetWindowLong(g_hWindow, GWL_STYLE, WS_OVERLAPPEDWINDOW | WS_VISIBLE);
		if(g_hMenu != NULL)
		{
			SetMenu(g_hWindow, g_hMenu);
			g_hMenu = NULL;
		}
		SetWindowPos(g_hWindow, HWND_NOTOPMOST,
				g_rectWindow.left, g_rectWindow.top,
				g_rectWindow.right - g_rectWindow.left,
				g_rectWindow.bottom - g_rectWindow.top,
				SWP_SHOWWINDOW);
	}
	else
	{
		SetWindowLong(g_hWindow, GWL_STYLE, WS_POPUP | WS_VISIBLE);
		if(g_hMenu == NULL)
		{
			g_hMenu = GetMenu(g_hWindow);
			SetMenu(g_hWindow, NULL);
		}
	}
}

/*-------------------------------------------
	DirectX Graphics̏I(ɎsƂĂ΂)
--------------------------------------------*/
bool CleanupDXGraphics(void)
{
	// 擾IuWFNg̊J
	RELEASE(g_pPixelShader);
	RELEASE(g_pVertexShader);
	RELEASE(g_pD3DIBuffer);
	RELEASE(g_pD3DVBColBuffer);
	RELEASE(g_pD3DVBXYZBuffer);
	RELEASE(g_pVertexDeclaration);

	RELEASE(g_pD3DDevice);
	RELEASE(g_pD3D);

	return true;
}

/*-------------------------------------------
	AvP[V̏IiŌɌĂ΂j
--------------------------------------------*/
bool CleanupApp(void)
{
	// j[Enh̍폜
	if (g_hMenu)
		DestroyMenu(g_hMenu);
	
	// EChEENX̓o^
	UnregisterClass(g_szWndClass, g_hInstance);
	return true;
}

/*-------------------------------------------
	EBhE
--------------------------------------------*/
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, UINT wParam, LONG lParam)
{
	HRESULT hr = S_OK;

	switch(msg)
	{
	case WM_ACTIVATE:
		g_bActive = (LOWORD(wParam) != 0);
		break;

	case WM_DESTROY:
		// D3DɊǗȂIuWFNg̏I
		CleanupD3DObject();
		// DirectX Graphics̏I
		CleanupDXGraphics();
		// EChE
		PostQuitMessage(0);
		g_hWindow = NULL;
		return 0;

	// EChEETCY̕ύX
	case WM_SIZE:
		if (g_D3DPP.Windowed != TRUE)
			break;

		if (!g_pD3DDevice || wParam == SIZE_MINIMIZED)
			break;
		g_D3DPP.BackBufferWidth  = LOWORD(lParam);
		g_D3DPP.BackBufferHeight = HIWORD(lParam);
		if(g_bDeviceLost)
			break;
		if (wParam == SIZE_MAXIMIZED || wParam == SIZE_RESTORED)
			ChangeWindowSize();
		break;

	case WM_SETCURSOR:
		if (g_D3DPP.Windowed != TRUE)
		{
			SetCursor(NULL);
			return 1;
		}
		break;

	case WM_KEYDOWN:
		// L[͂̏
		switch(wParam)
		{
		case VK_ESCAPE:	// [ESCAPE]L[ŃEChE
			PostMessage(hWnd, WM_CLOSE, 0, 0);
			break;

		case 'W':	// ʃ[h̐؂ւ
			ChangeDisplayMode();
			break;

		case 'F':	// tbgEVF[fBOɐ؂ւ
			if (g_pD3DDevice)
				g_pD3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_FLAT);
			break;

		case 'G':	// O[[EVF[fBOɐ؂ւ
			if (g_pD3DDevice)
				g_pD3DDevice->SetRenderState(D3DRS_SHADEMODE, D3DSHADE_GOURAUD);
			break;
		}
		break;

	case WM_COMMAND:
		// Iꂽj[s
		switch (LOWORD(wParam))
		{
		case IDM_EXIT:
			DestroyWindow(hWnd);
			return 0;
		}
		break;
	}

	// ftHg
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

/*--------------------------------------------
	ACh̏
--------------------------------------------*/
bool AppIdle(void)
{
	if (g_bD3DEmpty)
		return false;

	if (!g_bActive)
		return true;

	// foCX̕
	HRESULT hr;
	if (g_bDeviceLost)
	{
		Sleep(100);	// 0.1b҂

		// foCXԂ̃`FbN
		hr  = g_pD3DDevice->TestCooperativeLevel();
		if (FAILED(hr))
		{
			if (hr == D3DERR_DEVICELOST)
				return true;  // foCX͂܂Ă

			if (hr != D3DERR_DEVICENOTRESET)
				return false; // \ʃG[

			CleanupD3DObject(); // Direct3DŊǗĂȂ\[XJ
			hr = g_pD3DDevice->Reset(&g_D3DPP); // ݂
			if (FAILED(hr))
			{
				if (hr == D3DERR_DEVICELOST)
					return true; // foCX͂܂Ă

				DXTRACE_ERR("AppIdle Reset", hr);
				return false; // foCX̕Ɏs
			}
			hr = InitD3DObject();  // JDirect3DŊǗĂȂ\[XĎ擾
			if (FAILED(hr))
			{
				DXTRACE_ERR("AppIdle InitD3DObject", hr);
				return false;
			}
		}
		// foCX
		g_bDeviceLost = false;
	}

	// ʂ̍XV
	hr = Render();
	if (hr == D3DERR_DEVICELOST)
		g_bDeviceLost = true;	// foCX̏
	else if (FAILED(hr))
		return false;

	return true;
}

/*--------------------------------------------
	C
---------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	// AvP[VɊւ鏉
	HRESULT hr = InitApp(hInst);
	if (FAILED(hr))
	{
		DXTRACE_ERR("WinMain InitApp", hr);
		return 0;
	}

	// DirectX Graphics̏
	hr = InitDXGraphics();
	if (FAILED(hr))
		DXTRACE_ERR("WinMain InitDXGraphics", hr);
	else
	{
		// D3DɊǗȂIuWFNg̏
		hr = InitD3DObject();
		if (FAILED(hr))
		{
			DXTRACE_ERR("WinMain InitD3DObject", hr);
			DestroyWindow(g_hWindow);
		}
		else
			g_bD3DEmpty = false; // 
	}

	// bZ[WE[v
	MSG msg;
	do
	{
		if (PeekMessage(&msg, 0, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			// ACh
			if (!AppIdle())
				// G[ꍇCAvP[VI
				DestroyWindow(g_hWindow);
		}
	} while (msg.message != WM_QUIT);

	// AvP[V̏I
	CleanupApp();

	return msg.wParam;
}

